<?php

/**
 * This is the model class for table "album_image".
 *
 * The followings are the available columns in table 'album_image':
 * @property integer $id
 * @property string $title
 * @property string $slug
 * @property integer $create_datetime
 * @property integer $update_datetime
 * @property integer $order
 * @property integer $album_id
 *
 * The followings are the available model relations:
 * @property Album $album
 */
class AlbumImage extends CActiveRecord {

    /**
     * @return string the associated database table name
     */
    public function tableName() {
        return 'album_image';
    }

    public function beforeValidate() {
        if ($this->isNewRecord) {
            // set the create date, last updated date and the user doing the creating  
            $this->create_datetime = time();
            $this->update_datetime = time();
        } else {
            //not a new record, so just set the last updated time and last updated user id     
            $this->update_datetime = time();
        }
        return parent::beforeValidate();
    }

    protected function beforeSave() {
        if (strlen($this->slug) == 0) {
            $this->slug = Common::sanitize($this->title);
        }
        return parent::beforeSave();
    }

    /**
     * @return array validation rules for model attributes.
     */
    public function rules() {
        // NOTE: you should only define rules for those attributes that
        // will receive user inputs.
        return array(
            array('create_datetime, update_datetime', 'required'),
            array('title, slug, order, album_id', 'required', 'on' => 'update'),
            array('create_datetime, update_datetime, order, album_id', 'numerical', 'integerOnly' => true),
            array('title', 'length', 'max' => 200),
            array('slug', 'length', 'max' => 100),
            array('image', 'file', 'types' => 'jpg,jpeg,png,gif', 'maxSize' => 1024 * 1024 * 15 /* 15MB */, 'allowEmpty' => true),
            // The following rule is used by search().
            // @todo Please remove those attributes that should not be searched.
            array('id, title, slug, create_datetime, update_datetime, order, album_id', 'safe', 'on' => 'search'),
        );
    }

    /**
     * @return array relational rules.
     */
    public function relations() {
        // NOTE: you may need to adjust the relation name and the related
        // class name for the relations automatically generated below.
        return array(
            'album' => array(self::BELONGS_TO, 'Album', 'album_id'),
        );
    }

    /**
     * @return array customized attribute labels (name=>label)
     */
    public function attributeLabels() {
        return array(
            'id' => Yii::t('admin', 'ID'),
            'title' => Yii::t('admin', 'Title'),
            'slug' => Yii::t('admin', 'Slug'),
            'create_datetime' => Yii::t('admin', 'Create Datetime'),
            'update_datetime' => Yii::t('admin', 'Update Datetime'),
            'order' => Yii::t('admin', 'Order'),
            'album_id' => Yii::t('admin', 'Album'),
        );
    }

    /**
     * Retrieves a list of models based on the current search/filter conditions.
     *
     * Typical usecase:
     * - Initialize the model fields with values from filter form.
     * - Execute this method to get CActiveDataProvider instance which will filter
     * models according to data in model fields.
     * - Pass data provider to CGridView, CListView or any similar widget.
     *
     * @return CActiveDataProvider the data provider that can return the models
     * based on the search/filter conditions.
     */
    public function search() {
        // @todo Please modify the following code to remove attributes that should not be searched.

        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('title', $this->title, true);
        $criteria->compare('slug', $this->slug, true);
        $criteria->compare('create_datetime', $this->create_datetime);
        $criteria->compare('update_datetime', $this->update_datetime);
        $criteria->compare('order', $this->order);
        $criteria->compare('album_id', $this->album_id);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

    /**
     * Returns the static model of the specified AR class.
     * Please note that you should have this exact method in all your CActiveRecord descendants!
     * @param string $className active record class name.
     * @return AlbumImage the static model class
     */
    public static function model($className = __CLASS__) {
        return parent::model($className);
    }

}
